Package com.io7m.jtensors.core.unparameterized.matrices

# Class Matrix2x2D

java.lang.Object
com.io7m.jtensors.core.unparameterized.matrices.Matrix2x2D

All Implemented Interfaces:
  `MatrixComputationalType`, `Matrix2x2DType`, `MatrixReadable2x2DType`, `MatrixReadableDType`

    public final class Matrix2x2D
    extends java.lang.Object
    implements Matrix2x2DType

The type of 2x2 `double`-typed matrices.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `Matrix2x2D.Builder` | Builds instances of type `Matrix2x2D`.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static Matrix2x2D.Builder` | `builder()` | Creates a builder for `Matrix2x2D`.
  `static Matrix2x2D` | `copyOf​(Matrix2x2DType instance)` | Creates an immutable copy of a `Matrix2x2DType` value.
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `Matrix2x2D` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `r0c0`, `r0c1`, `r1c0`, `r1c1`.
  `static Matrix2x2D` | `of​(double r0c0, double r0c1, double r1c0, double r1c1)` | Construct a new immutable `Matrix2x2D` instance.
  `double` | `r0c0()` |
  `double` | `r0c1()` |
  `double` | `r1c0()` |
  `double` | `r1c1()` |
  `java.lang.String` | `toString()` | Prints the immutable value `Matrix2x2D` with attribute values.
  `Matrix2x2D` | `withR0c0​(double value)` | Copy the current immutable object by setting a value for the `r0c0` attribute.
  `Matrix2x2D` | `withR0c1​(double value)` | Copy the current immutable object by setting a value for the `r0c1` attribute.
  `Matrix2x2D` | `withR1c0​(double value)` | Copy the current immutable object by setting a value for the `r1c0` attribute.
  `Matrix2x2D` | `withR1c1​(double value)` | Copy the current immutable object by setting a value for the `r1c1` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.io7m.jtensors.core.unparameterized.matrices.MatrixReadable2x2DType

  `rowColumn`

- ## Method Details

  - ### r0c0

    public double r0c0()
    Specified by:
      `r0c0` in interface `Matrix2x2DType`
    Specified by:
      `r0c0` in interface `MatrixReadable2x2DType`
    Returns:
      The value at row 0 column 0

  - ### r0c1

    public double r0c1()
    Specified by:
      `r0c1` in interface `Matrix2x2DType`
    Specified by:
      `r0c1` in interface `MatrixReadable2x2DType`
    Returns:
      The value at row 0 column 1

  - ### r1c0

    public double r1c0()
    Specified by:
      `r1c0` in interface `Matrix2x2DType`
    Specified by:
      `r1c0` in interface `MatrixReadable2x2DType`
    Returns:
      The value at row 1 column 0

  - ### r1c1

    public double r1c1()
    Specified by:
      `r1c1` in interface `Matrix2x2DType`
    Specified by:
      `r1c1` in interface `MatrixReadable2x2DType`
    Returns:
      The value at row 1 column 1

  - ### withR0c0

    public final Matrix2x2D withR0c0​(double value)
    Copy the current immutable object by setting a value for the `r0c0` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for r0c0
    Returns:
      A modified copy of the `this` object

  - ### withR0c1

    public final Matrix2x2D withR0c1​(double value)
    Copy the current immutable object by setting a value for the `r0c1` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for r0c1
    Returns:
      A modified copy of the `this` object

  - ### withR1c0

    public final Matrix2x2D withR1c0​(double value)
    Copy the current immutable object by setting a value for the `r1c0` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for r1c0
    Returns:
      A modified copy of the `this` object

  - ### withR1c1

    public final Matrix2x2D withR1c1​(double value)
    Copy the current immutable object by setting a value for the `r1c1` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for r1c1
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `Matrix2x2D` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `r0c0`, `r0c1`, `r1c0`, `r1c1`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `Matrix2x2D` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### of

    public static Matrix2x2D of​(double r0c0, double r0c1, double r1c0, double r1c1)
    Construct a new immutable `Matrix2x2D` instance.
    Parameters:
      `r0c0` - The value for the `r0c0` attribute
      `r0c1` - The value for the `r0c1` attribute
      `r1c0` - The value for the `r1c0` attribute
      `r1c1` - The value for the `r1c1` attribute
    Returns:
      An immutable Matrix2x2D instance

  - ### copyOf

    public static Matrix2x2D copyOf​(Matrix2x2DType instance)
    Creates an immutable copy of a `Matrix2x2DType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable Matrix2x2D instance

  - ### builder

    public static Matrix2x2D.Builder builder()
    Creates a builder for `Matrix2x2D`.

         Matrix2x2D.builder()
            .setR0c0(double) // required r0c0
            .setR0c1(double) // required r0c1
            .setR1c0(double) // required r1c0
            .setR1c1(double) // required r1c1
            .build();

    Returns:
      A new Matrix2x2D builder